// Listen_ModeDlg.cpp : @
//

#include "stdafx.h"
#include "Listen_Mode.h"
#include "Listen_ModeDlg.h"
#include "..\..\lib\i8123w.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CListen_ModeDlg ܤ

CListen_ModeDlg::CListen_ModeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListen_ModeDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CListen_ModeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_BUTTON_LOADEDS, m_btn_loadeds);
	DDX_Control(pDX, IDC_COMBO_SLOT, m_slot);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
	DDX_Control(pDX, IDC_LIST_ENTRYDATA, m_entrydata);
}

BEGIN_MESSAGE_MAP(CListen_ModeDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_CBN_SELCHANGE(IDC_COMBO_SLOT, OnSelchangeComboSlot)
	ON_BN_CLICKED(IDC_BUTTON_LOADEDS, OnButtonLoadeds)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CListen_ModeDlg TBz`
BYTE SLOT=0;
BYTE BAUD=0;
BYTE NODE=1;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;

BYTE ISADD[128]={0};

BOOL CListen_ModeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w
	m_slot.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	for(WORD i = 0;i< 8;i++){
		CString str;

		str.Format(_T("%d"),i);
		m_slot.AddString(str);
	}

	for(WORD i = 1;i< 128;i++){
		CString str;

		if(i < 10) str.Format(_T("    %d"),i);
		else if(i < 100) str.Format(_T("  %d"),i);
		else str.Format(_T("%d"),i);
		
		m_node.AddString(str);
	}

	{
		m_baud.AddString(_T("    10 kbps"));
		m_baud.AddString(_T("    20 kbps"));
		m_baud.AddString(_T("    50 kbps"));
		m_baud.AddString(_T("  125 kbps"));
		m_baud.AddString(_T("  250 kbps"));
		m_baud.AddString(_T("  500 kbps"));
		m_baud.AddString(_T("  800 kbps"));
		m_baud.AddString(_T("1000 kbps"));
	}

	m_slot.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_shutdown.EnableWindow(FALSE);
	m_btn_addnode.EnableWindow(FALSE);
	m_btn_loadeds.EnableWindow(FALSE);
	m_btn_removenode.EnableWindow(FALSE);

	m_entrydata.ResetContent();

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CListen_ModeDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_LISTEN_MODE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_LISTEN_MODE_DIALOG));
	}
}
#endif


void CListen_ModeDlg::OnSelchangeComboSlot() 
{
	// TODO: Add your control notification handler code here
	SLOT = m_slot.GetCurSel();
}

void CListen_ModeDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CListen_ModeDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;

	if(ISADD[NODE]){
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);

		UpdateList();
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);

		m_entrydata.ResetContent();
	}
}

void CListen_ModeDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_InitMaster(SLOT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_btn_initial.EnableWindow(FALSE);
		m_btn_initial.ShowWindow(SW_HIDE);

		m_node.EnableWindow(TRUE);

		m_btn_shutdown.EnableWindow(TRUE);
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_loadeds.EnableWindow(TRUE);

		// Set to listen mode
		I8123_SetMasterMode(SLOT, 1, BlockMode);

		SetTimer(123,100,NULL);
	}
}

void CListen_ModeDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_ShutdownMaster(SLOT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_btn_initial.EnableWindow(TRUE);
		m_btn_initial.ShowWindow(SW_SHOW);

		m_btn_shutdown.EnableWindow(FALSE);
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_loadeds.EnableWindow(FALSE);
		m_btn_loadeds.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);

		m_node.EnableWindow(FALSE);
		m_node.SetCurSel(0);

		memset(ISADD,0,128);
		m_entrydata.ResetContent();

		KillTimer(123);
	}
}

void CListen_ModeDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	// Add Node manually
	ret = I8123_AddNode(SLOT, NODE, 2, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		BYTE EntryUse;
		WORD i, j, PDOId;
		DWORD EntryData[8];

		ISADD[NODE] = 1;

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_loadeds.EnableWindow(FALSE);
		m_btn_loadeds.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);

		// Set EMCY ID to master list
		I8123_SetEMCY_List(SLOT, NODE, (0x80 + NODE), BlockMode);

		// Install RxPDO to master PDO list
		for(i=0;i<4;i++){
			PDOId = 0x200 + NODE + (0x100*i);

			if(i==0) EntryUse = 8;
			else EntryUse = 4;

			for(j=0;j<EntryUse;j++){
				if(i==0) EntryData[j] = 0x62000108 + (0x00000100*j);
				else EntryData[j] = 0x64110110 + (0x00000100*(j+((i-1)*EntryUse)));
			}

			I8123_InstallPDO_List(SLOT, NODE, PDOId, 0, i+1, 255, 0, EntryUse, EntryData, BlockMode);
		}	

		// Install TxPDO to master PDO list
		for(i=0;i<4;i++){
			PDOId = 0x180 + NODE + (0x100*i);

			if(i==0) EntryUse = 8;
			else EntryUse = 4;

			for(j=0;j<EntryUse;j++){
				if(i==0) EntryData[j] = 0x60000108 + (0x00000100*j);
				else EntryData[j] = 0x64010110 + (0x00000100*(j+((i-1)*EntryUse)));
			}

			I8123_InstallPDO_List(SLOT, NODE, PDOId, 1, i+1, 255, 0, EntryUse, EntryData, BlockMode);
		}
	}
}

void CListen_ModeDlg::OnButtonLoadeds() 
{
	// TODO: Add your control notification handler code here
	CFileDialog Open(TRUE,NULL,NULL,OFN_HIDEREADONLY,_T("EDS File (*.eds)|*.eds"));

	INT_PTR nRet = Open.DoModal();
	if (nRet== IDOK)
	{
		char FileName[100] = {0};

		sprintf_s(FileName, 100, "%s", Open.GetPathName());
		
		ret = I8123_EDS_Load(SLOT, NODE, FileName, DelayTime, 200, BlockMode);
        if (ret != 0)
        {
			errstr.Format(_T("EDS File Load Error = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}
        else
        {
			ISADD[NODE] = 1;

            m_btn_addnode.EnableWindow(FALSE);
            m_btn_addnode.ShowWindow(SW_HIDE);
            m_btn_loadeds.EnableWindow(FALSE);
            m_btn_loadeds.ShowWindow(SW_HIDE);
            m_btn_removenode.EnableWindow(TRUE);
		}
	}
}

void CListen_ModeDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_RemoveNode(SLOT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		ISADD[NODE] = 0;

		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_loadeds.EnableWindow(TRUE);
		m_btn_loadeds.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);

		m_entrydata.ResetContent();
	}
}

void CListen_ModeDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
	I8123_ShutdownMaster(SLOT);
}

void CListen_ModeDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	UpdateList();
	
	CDialog::OnTimer(nIDEvent);
}

void CListen_ModeDlg::UpdateList()
{
	BYTE PDO_Cnt, NMT_State;
	WORD EMCYId, Id_List[10], i, j;
	CString Temp_Str;

	m_entrydata.ResetContent();

	ret = I8123_NMTGetState(SLOT, NODE, &NMT_State, BlockMode);
	if(!ret){
		Temp_Str.Format(_T("NMT State:"));
		switch(NMT_State){
		case 0x04:  // Stop mode
			Temp_Str.Format(_T("%s Stop mode"),Temp_Str);
			break;
		case 0x05:  // Operation mode
			Temp_Str.Format(_T("%s Operation mode"),Temp_Str);
			break;
		case 0x7F:	// Pre-operation mode
			Temp_Str.Format(_T("%s Pre-operation mode"),Temp_Str);
			break;
		}
		m_entrydata.AddString(Temp_Str);
	}

	ret = I8123_GetEMCYID(SLOT, NODE, &EMCYId, BlockMode);
	if(!ret){
		if(EMCYId){
			BYTE IsNew, Data[8]={0};
			ret = I8123_ReadLastEMCY(SLOT, NODE, &IsNew, Data, BlockMode);
			if(!ret || (ret == CPM_DataEmpty)){
				Temp_Str.Format(_T("EMCY %X : "),EMCYId);
				for(i=0;i<8;i++){
					Temp_Str.Format(_T("%s%02X "),Temp_Str,Data[i]);
				}
				m_entrydata.AddString(Temp_Str);
			}
		}
	}

	ret = I8123_GetRxPDOID(SLOT, NODE, &PDO_Cnt, Id_List, BlockMode);
	if(!ret){
		BYTE IsNew, DLen, Data[8];

		for(i=0;i<PDO_Cnt;i++){
			memset(Data,0,8);

			ret = I8123_GetPDOLastData(SLOT, Id_List[i], &IsNew, &DLen, Data, BlockMode);
			if(!ret || (ret == CPM_DataEmpty)){
				Temp_Str.Format(_T("RxPDO %X : "),Id_List[i]);
				for(j=0;j<8;j++){
					Temp_Str.Format(_T("%s%02X "),Temp_Str,Data[j]);
				}
				m_entrydata.AddString(Temp_Str);
			}
		}
	}

	ret = I8123_GetTxPDOID(SLOT, NODE, &PDO_Cnt, Id_List, BlockMode);
	if(!ret){
		BYTE IsNew, DLen, Data[8];

		for(i=0;i<PDO_Cnt;i++){
			memset(Data,0,8);

			ret = I8123_GetPDOLastData(SLOT, Id_List[i], &IsNew, &DLen, Data, BlockMode);
			if(!ret || (ret == CPM_DataEmpty)){
				Temp_Str.Format(_T("TxPDO %X : "),Id_List[i]);
				for(j=0;j<8;j++){
					Temp_Str.Format(_T("%s%02X "),Temp_Str,Data[j]);
				}
				m_entrydata.AddString(Temp_Str);
			}
		}
	}
}
