// PDO_ParameterDlg.cpp : @
//

#include "stdafx.h"
#include "PDO_Parameter.h"
#include "PDO_ParameterDlg.h"
#include "..\..\lib\i8123w.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CPDO_ParameterDlg ܤ

CPDO_ParameterDlg::CPDO_ParameterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPDO_ParameterDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPDO_ParameterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_COMBO_PDOTYPE, m_pdotype);
	DDX_Control(pDX, IDC_COMBO_PDOID, m_pdoid);
	DDX_Control(pDX, IDC_BUTTON_INSTALLPDO, m_btn_installpdo);
	DDX_Control(pDX, IDC_LIST_MAPDATA, m_mapdata);
	DDX_Control(pDX, IDC_EDIT_USEENTRY, m_useentry);
	DDX_Control(pDX, IDC_EDIT_TXTYPE, m_transmittype);
	DDX_Control(pDX, IDC_EDIT_INSTPDONO, m_installpdono);
	DDX_Control(pDX, IDC_EDIT_INSTPDOID, m_installpdoid);
	DDX_Control(pDX, IDC_EDIT_EVENTTIMER, m_eventtimer);
	DDX_Control(pDX, IDC_EDIT_DYENTRYDATA, m_setentrydata);
	DDX_Control(pDX, IDC_EDIT_DYENTRY, m_setentry);
	DDX_Control(pDX, IDC_EDIT_CHANGEPDOID, m_changepdoid);
	DDX_Control(pDX, IDC_COMBO_SLOT, m_slot);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_INSTRXTXTYPE, m_rxtxtype);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_REMOVEPDO, m_btn_removepdo);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_PDOUSEENTRY, m_btn_useentry);
	DDX_Control(pDX, IDC_BUTTON_PDOTXTYPE, m_btn_txtype);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_EVENTTIMER, m_btn_eventtimer);
	DDX_Control(pDX, IDC_BUTTON_CHANGEPDO, m_btn_changepdo);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
	DDX_Control(pDX, IDC_BUTTON_DYNAMICPDO, m_btn_dynamicpdo);
}

BEGIN_MESSAGE_MAP(CPDO_ParameterDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_CHANGEPDO, OnButtonChangepdo)
	ON_BN_CLICKED(IDC_BUTTON_DYNAMICPDO, OnButtonDynamicpdo)
	ON_BN_CLICKED(IDC_BUTTON_EVENTTIMER, OnButtonEventtimer)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_INSTALLPDO, OnButtonInstallpdo)
	ON_BN_CLICKED(IDC_BUTTON_PDOTXTYPE, OnButtonPdotxtype)
	ON_BN_CLICKED(IDC_BUTTON_PDOUSEENTRY, OnButtonPdouseentry)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_REMOVEPDO, OnButtonRemovepdo)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_CBN_SELCHANGE(IDC_COMBO_SLOT, OnSelchangeComboSlot)
	ON_CBN_SELCHANGE(IDC_COMBO_PDOID, OnSelchangeComboPdoid)
	ON_CBN_SELCHANGE(IDC_COMBO_PDOTYPE, OnSelchangeComboPdotype)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CPDO_ParameterDlg TBz`
BYTE SLOT=0;
BYTE BAUD=0;
BYTE NODE=1;

BYTE BlockMode = 1;

BYTE PDOTYPE = 0;
WORD PDOCOBID = 0;

WORD DelayTime=0;
WORD ret;
CString errstr;

void CPDO_ParameterDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_btn_installpdo.EnableWindow(FALSE);
		m_btn_dynamicpdo.EnableWindow(FALSE);
		m_btn_removepdo.EnableWindow(FALSE);
		m_btn_changepdo.EnableWindow(FALSE);
		m_btn_eventtimer.EnableWindow(FALSE);
		m_btn_txtype.EnableWindow(FALSE);
		m_btn_useentry.EnableWindow(FALSE);

		m_pdotype.EnableWindow(FALSE);
		m_pdoid.EnableWindow(FALSE);
		m_rxtxtype.EnableWindow(FALSE);

		m_installpdoid.EnableWindow(FALSE);
		m_installpdono.EnableWindow(FALSE);
		m_setentry.EnableWindow(FALSE);
		m_setentrydata.EnableWindow(FALSE);
		m_changepdoid.EnableWindow(FALSE);
		m_useentry.EnableWindow(FALSE);
		m_transmittype.EnableWindow(FALSE);
		m_eventtimer.EnableWindow(FALSE);
		m_mapdata.EnableWindow(FALSE);
	}
	else{
		m_btn_installpdo.EnableWindow(TRUE);
		m_btn_dynamicpdo.EnableWindow(TRUE);
		m_btn_removepdo.EnableWindow(TRUE);
		m_btn_changepdo.EnableWindow(TRUE);
		m_btn_eventtimer.EnableWindow(TRUE);
		m_btn_txtype.EnableWindow(TRUE);
		m_btn_useentry.EnableWindow(TRUE);

		m_pdotype.EnableWindow(TRUE);
		m_pdoid.EnableWindow(TRUE);
		m_rxtxtype.EnableWindow(TRUE);

		m_installpdoid.EnableWindow(TRUE);
		m_installpdono.EnableWindow(TRUE);
		m_setentry.EnableWindow(TRUE);
		m_setentrydata.EnableWindow(TRUE);
		m_changepdoid.EnableWindow(TRUE);
		m_useentry.EnableWindow(TRUE);
		m_transmittype.EnableWindow(TRUE);
		m_eventtimer.EnableWindow(TRUE);
		m_mapdata.EnableWindow(TRUE);
	}
}

BOOL CPDO_ParameterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w
	m_slot.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_addnode.EnableWindow(FALSE);

	for(WORD i = 0;i< 8;i++){
		CString str;

		str.Format(_T("%d"),i);
		m_slot.AddString(str);
	}

	for(WORD i = 1;i< 128;i++){
		CString str;

		if(i < 10) str.Format(_T("    %d"),i);
		else if(i < 100) str.Format(_T("  %d"),i);
		else str.Format(_T("%d"),i);
		
		m_node.AddString(str);
	}

	{
		m_baud.AddString(_T("    10 kbps"));
		m_baud.AddString(_T("    20 kbps"));
		m_baud.AddString(_T("    50 kbps"));
		m_baud.AddString(_T("  125 kbps"));
		m_baud.AddString(_T("  250 kbps"));
		m_baud.AddString(_T("  500 kbps"));
		m_baud.AddString(_T("  800 kbps"));
		m_baud.AddString(_T("1000 kbps"));
	}

	m_slot.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);

	m_installpdoid.SetLimitText(3);
	m_installpdono.SetLimitText(3);
	m_setentry.SetLimitText(2);
	m_setentrydata.SetLimitText(8);
	m_changepdoid.SetLimitText(3);
	m_transmittype.SetLimitText(3);
	m_useentry.SetLimitText(2);
	m_eventtimer.SetLimitText(5);

	Enable_Disable(FALSE);

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CPDO_ParameterDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_PDO_PARAMETER_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_PDO_PARAMETER_DIALOG));
	}
}
#endif


BOOL CPDO_ParameterDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_CHAR){	// Check "WM_CHAR" message
		if( (pMsg->hwnd == m_installpdono.m_hWnd) || (pMsg->hwnd == m_transmittype.m_hWnd) || 
			(pMsg->hwnd == m_useentry.m_hWnd)     || (pMsg->hwnd == m_eventtimer.m_hWnd)   ||
			(pMsg->hwnd == m_setentry.m_hWnd)){
			if( ((pMsg->wParam >= 0x30) && (pMsg->wParam <= 0x39)) || (pMsg->wParam == 0x08) ){
				return CDialog::PreTranslateMessage(pMsg);	// pass "0 ~ 9" and "Back"
			}
			else{
				return TRUE;
			}
		}
		else if( (pMsg->hwnd == m_installpdoid.m_hWnd) || (pMsg->hwnd == m_setentrydata.m_hWnd) || 
			     (pMsg->hwnd == m_changepdoid.m_hWnd)){
			if( ((pMsg->wParam >= 0x30) && (pMsg->wParam <= 0x39)) || 
				((pMsg->wParam >= 0x41) && (pMsg->wParam <= 0x46)) ||
				((pMsg->wParam >= 0x61) && (pMsg->wParam <= 0x66)) ||
				 (pMsg->wParam == 0x08)){
				return CDialog::PreTranslateMessage(pMsg);	// pass "0 ~ 9" , "A ~ F" , "a ~ f" , and "Back"
			}
			else{
				return TRUE;
			}
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CPDO_ParameterDlg::OnSelchangeComboSlot() 
{
	// TODO: Add your control notification handler code here
	SLOT = m_slot.GetCurSel();
}

void CPDO_ParameterDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CPDO_ParameterDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;
}

void CPDO_ParameterDlg::OnSelchangeComboPdotype() 
{
	// TODO: Add your control notification handler code here
	PDOTYPE = m_pdotype.GetCurSel();

	// Get total RxPDO COB-ID of the node
	GetPDOID();
}

void CPDO_ParameterDlg::OnSelchangeComboPdoid() 
{
	// TODO: Add your control notification handler code here
	GetPDOMapData();
}

void CPDO_ParameterDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_InitMaster(SLOT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_addnode.EnableWindow(TRUE);
	}
}

void CPDO_ParameterDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_ShutdownMaster(SLOT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);

		Enable_Disable(FALSE);
	}
}

void CPDO_ParameterDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_AddNode(SLOT, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_rxtxtype.SetCurSel(0);
		m_pdotype.SetCurSel(0);

		// Get total RxPDO COB-ID of the node
		GetPDOID();

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_node.EnableWindow(FALSE);

		Enable_Disable(TRUE);
	}
}

void CPDO_ParameterDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_RemoveNode(SLOT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_node.EnableWindow(TRUE);

		Enable_Disable(FALSE);
	}
}

void CPDO_ParameterDlg::OnButtonInstallpdo() 
{
	BYTE RxTx;
	WORD Cobid, PDO_No;
	TCHAR T_TempStr[10];
	TCHAR *end_str;
	// TODO: Add your control notification handler code here

	m_installpdoid.GetWindowText(T_TempStr,5);
	Cobid = (WORD)wcstoul(T_TempStr,&end_str,16);

	m_installpdono.GetWindowText(T_TempStr,5);
	PDO_No = (WORD)wcstoul(T_TempStr,&end_str,10);

	RxTx = m_rxtxtype.GetCurSel();

	ret = I8123_InstallPDO(SLOT, NODE, Cobid, RxTx, PDO_No, BlockMode);
	if(ret){
		errstr.Format(_T("InstallPDO Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		if(PDOTYPE == RxTx){
			GetPDOID();
		}
	}
}

void CPDO_ParameterDlg::OnButtonRemovepdo() 
{
	TCHAR T_TempStr[10];
	TCHAR *end_str;
	BYTE Entry;
	// TODO: Add your control notification handler code here
	
	m_setentry.GetWindowText(T_TempStr,3);
	Entry = (BYTE)wcstoul(T_TempStr,&end_str,10);

	ret = I8123_RemovePDO(SLOT, NODE, PDOCOBID, Entry, BlockMode);
	if(ret){
		errstr.Format(_T("RemovePDO Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		if(Entry){	// Entry != 0, Remove single entry
			GetPDOMapData();
		}
		else{		// Entry = 0, Remove whole PDO
			GetPDOID();
		}
	}
}

void CPDO_ParameterDlg::OnButtonDynamicpdo() 
{
	TCHAR T_TempStr[20];
	TCHAR *end_str;
	BYTE Entry;
	DWORD EntryData;
	// TODO: Add your control notification handler code here

	m_setentry.GetWindowText(T_TempStr,3);
	Entry = (BYTE)wcstoul(T_TempStr,&end_str,10);

	m_setentrydata.GetWindowText(T_TempStr,10);
	EntryData = (DWORD)wcstoul(T_TempStr,&end_str,16);

	ret = I8123_DynamicPDO(SLOT, NODE, PDOCOBID, PDOTYPE, Entry, EntryData, BlockMode);
	if(ret){
		errstr.Format(_T("DynamicPDO Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		GetPDOMapData();
	}
}

void CPDO_ParameterDlg::OnButtonChangepdo() 
{
	TCHAR T_TempStr[20];
	TCHAR *end_str;
	WORD New_PDO;
	// TODO: Add your control notification handler code here

	m_changepdoid.GetWindowText(T_TempStr,5);
	New_PDO = (WORD)wcstoul(T_TempStr,&end_str,16);

	ret = I8123_ChangePDOID(SLOT, PDOCOBID, New_PDO, BlockMode);
	if(ret){
		errstr.Format(_T("ChangePDOID Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		GetPDOID();
	}
}

void CPDO_ParameterDlg::OnButtonPdotxtype() 
{
	TCHAR T_TempStr[10];
	TCHAR *end_str;
	BYTE Tx_Type;
	// TODO: Add your control notification handler code here

	m_transmittype.GetWindowText(T_TempStr,5);
	Tx_Type = (BYTE)wcstoul(T_TempStr,&end_str,10);

	ret = I8123_PDOTxType(SLOT, PDOCOBID, Tx_Type, BlockMode);
	if(ret){
		errstr.Format(_T("PDOTxType Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		GetPDOMapData();
	}
}

void CPDO_ParameterDlg::OnButtonPdouseentry() 
{
	TCHAR T_TempStr[10];
	TCHAR *end_str;
	BYTE Entry;
	// TODO: Add your control notification handler code here

	m_useentry.GetWindowText(T_TempStr,5);
	Entry = (BYTE)wcstoul(T_TempStr,&end_str,10);

	ret = I8123_PDOUseEntry(SLOT, PDOCOBID, Entry, BlockMode);
	if(ret){
		errstr.Format(_T("PDOUseEntr Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		GetPDOMapData();
	}
}

void CPDO_ParameterDlg::OnButtonEventtimer() 
{
	TCHAR T_TempStr[20];
	TCHAR *end_str;
	WORD Timer;
	// TODO: Add your control notification handler code here

	m_eventtimer.GetWindowText(T_TempStr,10);
	Timer = (WORD)wcstoul(T_TempStr,&end_str,10);

	ret = I8123_PDOEventTimer(SLOT, PDOCOBID, Timer, BlockMode);
	if(ret){
		errstr.Format(_T("PDOEventTimer Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		GetPDOMapData();
	}
}

void CPDO_ParameterDlg::GetPDOID()
{
	BYTE PDO_Cnt;
	WORD Id_List[10],i;
	CString PDO_Str;

	m_pdoid.ResetContent();

	if(PDOTYPE){
		ret = I8123_GetTxPDOID(SLOT, NODE, &PDO_Cnt, Id_List, BlockMode);
	}
	else{
		ret = I8123_GetRxPDOID(SLOT, NODE, &PDO_Cnt, Id_List, BlockMode);
	}

	if(!ret){
		for(i=0;i<PDO_Cnt;i++){
			PDO_Str.Format(_T("%X"),Id_List[i]);
			m_pdoid.AddString(PDO_Str);
		}
	}

	m_pdoid.SetCurSel(0);

	GetPDOMapData();
}

void CPDO_ParameterDlg::GetPDOMapData()
{
	WORD PDO_Index,PDO_No,i;
	TCHAR T_TempStr[10];
	TCHAR *end_str;

	BYTE PDO_Type, Transmit_Type, Entry_Cnt;
	WORD Event_Timer;
	DWORD Map_Data[10];
	CString PDO_Str;

	m_mapdata.ResetContent();
	PDOCOBID = 0;

	if(!m_pdoid.GetCount()) return;

	PDO_Index = m_pdoid.GetCurSel();

	// Convert text to PDO ID number
	m_pdoid.GetLBText(PDO_Index,T_TempStr);
	PDOCOBID = (WORD)wcstoul(T_TempStr,&end_str,16);

	// Get Mapping Data
	ret = I8123_GetPDOMapInfo(SLOT, PDOCOBID, &PDO_No, &PDO_Type, &Transmit_Type, &Event_Timer, &Entry_Cnt, Map_Data, BlockMode);
	if(!ret){
		PDO_Str.Format(_T("Transmission Type: %d"),Transmit_Type);
		m_mapdata.AddString(PDO_Str);

		PDO_Str.Format(_T("Event Timer: %u"),Event_Timer);
		m_mapdata.AddString(PDO_Str);

		PDO_Str.Format(_T("Mapping Data:"));
		m_mapdata.AddString(PDO_Str);

		for(i=0;i<Entry_Cnt;i++){
			PDO_Str.Format(_T("Entry %d: %08lX"),i+1,Map_Data[i]);
			m_mapdata.AddString(PDO_Str);
		}
	}
}

void CPDO_ParameterDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	I8123_ShutdownMaster(SLOT);
}
