// SDO_WriteDlg.cpp : @
//

#include "stdafx.h"
#include "SDO_Write.h"
#include "SDO_WriteDlg.h"
#include "..\..\lib\i8123w.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSDO_WriteDlg ܤ

CSDO_WriteDlg::CSDO_WriteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSDO_WriteDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSDO_WriteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_EDIT_DATA3, m_data3);
	DDX_Control(pDX, IDC_EDIT_DATA2, m_data2);
	DDX_Control(pDX, IDC_EDIT_DATA1, m_data1);
	DDX_Control(pDX, IDC_EDIT_DATA0, m_data0);
	DDX_Control(pDX, IDC_LIST_SDOLIST, m_sdolist);
	DDX_Control(pDX, IDC_EDIT_SUBINDEX, m_subindex);
	DDX_Control(pDX, IDC_EDIT_INDEX, m_index);
	DDX_Control(pDX, IDC_COMBO_SLOT, m_slot);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_LEN, m_len);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_SDOSEND, m_btn_sdosend);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_btn_clear);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
}

BEGIN_MESSAGE_MAP(CSDO_WriteDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	ON_CBN_SELCHANGE(IDC_COMBO_SLOT, OnSelchangeComboSlot)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_LEN, OnSelchangeComboLen)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_SDOSEND, OnButtonSdosend)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CSDO_WriteDlg TBz`
BYTE SLOT=0;
BYTE BAUD=0;
BYTE NODE=1;
BYTE LEN=1;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;

void CSDO_WriteDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_len.EnableWindow(FALSE);

		m_btn_removenode.EnableWindow(FALSE);
		m_btn_sdosend.EnableWindow(FALSE);
		m_btn_clear.EnableWindow(FALSE);
		m_index.EnableWindow(FALSE);
		m_subindex.EnableWindow(FALSE);
		m_data0.EnableWindow(FALSE);
		m_data1.EnableWindow(FALSE);
		m_data2.EnableWindow(FALSE);
		m_data3.EnableWindow(FALSE);
	}
	else{
		m_len.EnableWindow(TRUE);

		m_btn_removenode.EnableWindow(TRUE);
		m_btn_sdosend.EnableWindow(TRUE);
		m_btn_clear.EnableWindow(TRUE);
		m_index.EnableWindow(TRUE);
		m_subindex.EnableWindow(TRUE);
		m_data0.EnableWindow(TRUE);
		m_data1.EnableWindow(TRUE);
		m_data2.EnableWindow(TRUE);
		m_data3.EnableWindow(TRUE);
	}
}

BOOL CSDO_WriteDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w
	
	m_slot.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);
	
	m_btn_initial.EnableWindow(TRUE);
	m_btn_addnode.EnableWindow(FALSE);
	
	Enable_Disable(FALSE);

	for(WORD i = 0;i< 8;i++){
		CString str;

		str.Format(_T("%d"),i);
		m_slot.AddString(str);
	}

	for(WORD i = 1;i< 128;i++){
		CString str;

		if(i < 10) str.Format(_T("    %d"),i);
		else if(i < 100) str.Format(_T("  %d"),i);
		else str.Format(_T("%d"),i);
		
		m_node.AddString(str);
	}

	{
		m_baud.AddString(_T("    10 kbps"));
		m_baud.AddString(_T("    20 kbps"));
		m_baud.AddString(_T("    50 kbps"));
		m_baud.AddString(_T("  125 kbps"));
		m_baud.AddString(_T("  250 kbps"));
		m_baud.AddString(_T("  500 kbps"));
		m_baud.AddString(_T("  800 kbps"));
		m_baud.AddString(_T("1000 kbps"));
	}

	m_slot.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);
	m_len.SetCurSel(0);
	m_index.LimitText(4);
	m_subindex.LimitText(2);
	m_data0.LimitText(2);
	m_data1.LimitText(2);
	m_data2.LimitText(2);
	m_data3.LimitText(2);
	m_index.SetWindowText(_T("1000"));
	m_subindex.SetWindowText(_T("00"));
	m_data0.SetWindowText(_T("12"));
	m_data1.SetWindowText(_T("34"));
	m_data2.SetWindowText(_T("AB"));
	m_data3.SetWindowText(_T("CD"));
	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSDO_WriteDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SDO_WRITE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SDO_WRITE_DIALOG));
	}
}
#endif


BOOL CSDO_WriteDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_CHAR)
	{
		if( ((pMsg->wParam >= 0x30) && (pMsg->wParam <= 0x39)) || 
			((pMsg->wParam >= 0x41) && (pMsg->wParam <= 0x46)) ||
			((pMsg->wParam >= 0x61) && (pMsg->wParam <= 0x66)) ||
			 (pMsg->wParam == 0x08) ){
		}
		else{
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CSDO_WriteDlg::OnSelchangeComboSlot() 
{
	// TODO: Add your control notification handler code here
	SLOT = m_slot.GetCurSel();
}

void CSDO_WriteDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CSDO_WriteDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;
}

void CSDO_WriteDlg::OnSelchangeComboLen() 
{
	// TODO: Add your control notification handler code here
	LEN = m_len.GetCurSel()+1;
}

void CSDO_WriteDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_InitMaster(SLOT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_addnode.EnableWindow(TRUE);
	}
}

void CSDO_WriteDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_ShutdownMaster(SLOT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);

		Enable_Disable(FALSE);
	}
}

void CSDO_WriteDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_AddNode(SLOT, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_node.EnableWindow(FALSE);

		Enable_Disable(TRUE);
	}
}

void CSDO_WriteDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_RemoveNode(SLOT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_node.EnableWindow(TRUE);

		Enable_Disable(FALSE);
	}
}

void CSDO_WriteDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	m_sdolist.ResetContent();
}

void CSDO_WriteDlg::OnButtonSdosend() 
{
	WORD i;
	WORD RDLen, n_INDEX;
	BYTE RData[20], n_DATA[4], n_SUBINDEX;
	CString DataStr, TempStr;
	wchar_t *end_str;
	// TODO: Add your control notification handler code here

	m_index.GetWindowText(TempStr);
	n_INDEX = (WORD)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_subindex.GetWindowText(TempStr);
	n_SUBINDEX = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_data0.GetWindowText(TempStr);
	n_DATA[0] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_data1.GetWindowText(TempStr);
	n_DATA[1] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_data2.GetWindowText(TempStr);
	n_DATA[2] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_data3.GetWindowText(TempStr);
	n_DATA[3] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	ret = I8123_SDOWriteData(SLOT, NODE, n_INDEX, n_SUBINDEX, LEN, n_DATA, &RDLen, RData, BlockMode);
	if(ret && ret != CPM_Abort){
		errstr.Format(_T("SDO Write Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("%04X-%02X: "),n_INDEX, n_SUBINDEX);
		
		for(i=0;i<RDLen;i++){
			DataStr.Format(_T("%s%02X "),DataStr,RData[i]);
		}

		if(ret == CPM_Abort) DataStr.Format(_T("%s%: Write Abort"),DataStr);
		else DataStr.Format(_T("%s%: Write OK"),DataStr);

		m_sdolist.AddString(DataStr);
	}
}

void CSDO_WriteDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	I8123_ShutdownMaster(SLOT);
}
